
/* Demo: << >> bit shift operators
 *
 *   gcc ijc-shift-test1.c
 *   gcc ijc-shift-test1.c -O3
 *
 */

#include <stdio.h>

#define PRINT(x) do { int v=(x); printf(#x "\t= %d\t 0x%08X \n", v, v); } while(0)

int main(void) {
    int i;
    unsigned u;

    printf("\n");
    PRINT( i=-10 );
    PRINT( u=0xF0 );
    printf("\n");
    PRINT( i>>1 );
    PRINT( u>>1 );
    printf("\nundefined behaviour for 32bit int:\n");
    PRINT( i<<32 );
    PRINT( u<<32 );
    printf("\n-1>>1 is not the same as -1/2 :\n");
    PRINT( i=-1 );
    PRINT( i>>1 );
    printf("\n");
    PRINT( u=-1 );
    PRINT( u>>=1 );
    PRINT( i=~u );
    PRINT( i>>1 );
    PRINT( (i>>1)*2 );
    printf("\n");
}
